=== debian/control ===
Source: ros-humble-rtabmap-util
Section: misc
Priority: optional
Maintainer: Mathieu Labbe <matlabbe@gmail.com>
Build-Depends: debhelper (>= 9.0.0), ros-humble-ament-cmake, ros-humble-cv-bridge, ros-humble-image-transport, ros-humble-laser-geometry, ros-humble-message-filters, ros-humble-nav-msgs, ros-humble-octomap-msgs, ros-humble-pcl-conversions, ros-humble-pcl-ros, ros-humble-rclcpp, ros-humble-rclcpp-components, ros-humble-rtabmap-conversions, ros-humble-rtabmap-msgs, ros-humble-sensor-msgs, ros-humble-std-msgs, ros-humble-stereo-msgs, ros-humble-tf2, ros-humble-tf2-ros, ros-humble-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-humble-rtabmap-util
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-humble-cv-bridge, ros-humble-image-transport, ros-humble-laser-geometry, ros-humble-message-filters, ros-humble-nav-msgs, ros-humble-octomap-msgs, ros-humble-pcl-conversions, ros-humble-pcl-ros, ros-humble-rclcpp, ros-humble-rclcpp-components, ros-humble-rtabmap-conversions, ros-humble-rtabmap-msgs, ros-humble-sensor-msgs, ros-humble-std-msgs, ros-humble-stereo-msgs, ros-humble-tf2, ros-humble-tf2-ros, ros-humble-ros-workspace
Description: RTAB-Map's various useful nodes and nodelets.
